#!/usr/bin/perl

# generate the case tables




if(!open(OUTPUT,">","kvi_wstring_tables.cpp"))
{
	print "Can't open kvi_wstring_tables.cpp for writing\n";
	exit(0);
}
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = gmtime(time);
$year = 1900 + $year;
print OUTPUT "//=============================================================================\n";
print OUTPUT "//\n";
print OUTPUT "//   File : kvi_wstring_tables.cpp\n";
print OUTPUT "//   Creation date : Thu 06 Dec 2002 03:19:00 by Szymon Stefanek\n";
print OUTPUT "//   Last update : ".$mday.".".$mon.".".$year." ".$hour.":".$min.":".$sec." GMT\n";
print OUTPUT "//\n";
print OUTPUT "//   This file is part of the KVirc irc client distribution\n";
print OUTPUT "//   Copyright (C) 2002 Szymon Stefanek (pragma at kvirc dot net)\n";
print OUTPUT "//\n";
print OUTPUT "//   This program is FREE software. You can redistribute it and/or\n";
print OUTPUT "//   modify it under the terms of the GNU General Public License\n";
print OUTPUT "//   as published by the Free Software Foundation; either version 2\n";
print OUTPUT "//   of the License, or (at your opinion) any later version.\n";
print OUTPUT "//\n";
print OUTPUT "//   This program is distributed in the HOPE that it will be USEFUL,\n";
print OUTPUT "//   but WITHOUT ANY WARRANTY; without even the implied warranty of\n";
print OUTPUT "//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n";
print OUTPUT "//   See the GNU General Public License for more details.\n";
print OUTPUT "//\n";
print OUTPUT "//   You should have received a copy of the GNU General Public License\n";
print OUTPUT "//   along with this program. If not, write to the Free Software Foundation,\n";
print OUTPUT "//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n";
print OUTPUT "//\n";
print OUTPUT "//=============================================================================\n";
print OUTPUT "\n\n";


print OUTPUT "#define _KVI_WSTRING_TABLES_CPP_\n";
print OUTPUT "#define __WSTRINGLIB__\n\n";

print OUTPUT "#include \"kvi_wstring_wchar.h\"\n\n";

for $row (0..255)
{
	for $col (0..255)
	{
		$ltumap{$row.",".$col} = "0"; #"0x".sprintf("%04X",($row * 256) + $col);
		$utlmap{$row.",".$col} = "0"; #"0x".sprintf("%04X",($row * 256) + $col);
		#print $ltumap{$row.",".$col}."\n";
	}
}

if(open(CASEMAPPING,"CaseFolding.txt"))
{
	$lowchar = "";
	$upchar = "";
	while(<CASEMAPPING>)
	{
		if(!/^#/)
		{
			@fields = split /;/;
			$upchar = shift @fields;
			$dummy = shift @fields;
			$lowchar = shift @fields;

			$upchar =~ s/ //g;
			$lowchar =~ s/ //g;

			if(($lowchar ne "") && ($upchar ne "") && (length($lowchar) < 5) && (length($upchar) < 5))
			{
				$row1 = int(hex($lowchar) / 256);
				if($row1 < 256)
				{
					$row2 = int(hex($upchar) / 256);
					if($row2 < 256)
					{
						$col1 = hex($lowchar) % 256;
						$col2 = hex($upchar) % 256;
						$ltumap{$row1.",".$col1} = $upchar;
						$utlmap{$row2.",".$col2} = $lowchar;
					}
				}
			}
		}
	}

	close(CASEMAPPING);
} else {
	print "Can't open CaseFolding.txt\n";
}


$casemappingbytes = 0;

print OUTPUT "//=======================================================\n";
print OUTPUT "// CASE MAPPING TABLES\n";
print OUTPUT "//=======================================================\n\n\n";


print OUTPUT "static kvi_wchar_t case_xtx_XX[256] =\n";
print OUTPUT "{\n";
for $row (0..255)
{
	if(($row % 16) == 0)
	{
		print OUTPUT "	";
	}
	print OUTPUT "0x000";
	if($row != 255)
	{
		print OUTPUT ",";
	}
	if(($row % 16) == 15)
	{
		print OUTPUT "\n";
	} else {
		print OUTPUT " ";
	}
	$casemappingbytes += 2;
}
print OUTPUT "};\n\n";


for $row (0..255)
{
	# check if this ltu row has data in columns
	$bOk = 0;
	TEST: for $col (0..255)
	{
		if($ltumap{$row.",".$col} ne "0")
		{
			$bOk = 1;
			last TEST;
		}
	}

	if($bOk)
	{
		$lturow[$row] = 1;
		print OUTPUT "static kvi_wchar_t case_ltu_".sprintf("%02X",$row)."[256] =\n";
		print OUTPUT "{\n";
		for $col (0..255)
		{
			if(($col % 16) == 0)
			{
				print OUTPUT "	";
			}
			if($ltumap{$row.",".$col} eq "0")
			{
				print OUTPUT "0x0000";
			} else {
				print OUTPUT "0x".$ltumap{$row.",".$col};
			}
			if($col != 255)
			{
				print OUTPUT ",";
			}
			if(($col % 16) == 15)
			{
				print OUTPUT "\n";
			} else {
				print OUTPUT " ";
			}
			$casemappingbytes += 2;
		}
		print OUTPUT "};\n\n\n";
	} else {
		$lturow[$row] = 0;
	}
}



print OUTPUT "kvi_wchar_t * kvirc_case_map_ltu[256] =\n";
print OUTPUT "{\n";
for $row (0..255)
{
	if(($row % 8) == 0)
	{
		print OUTPUT "	";
	}
	if($lturow[$row] == 0)
	{
		print OUTPUT "case_xtx_XX";
	} else {
		print OUTPUT "case_ltu_".sprintf("%02X",$row);
	}
	if($row != 255)
	{
		print OUTPUT ",";
	}
	if(($row % 8) == 7)
	{
		print OUTPUT "\n";
	} else {
		print OUTPUT " ";
	}
	$casemappingbytes += 4;
}
print OUTPUT "};\n\n\n";



for $row (0..255)
{
	# check if this utl row has data in columns
	$bOk = 0;
	TEST: for $col (0..255)
	{
		if($utlmap{$row.",".$col} ne "0")
		{
			$bOk = 1;
			last TEST;
		}
	}

	if($bOk)
	{
		$utlrow[$row] = 1;
		print OUTPUT "static kvi_wchar_t case_utl_".sprintf("%02X",$row)."[256] =\n";
		print OUTPUT "{\n";
		for $col (0..255)
		{
			if(($col % 16) == 0)
			{
				print OUTPUT "	";
			}
			if($utlmap{$row.",".$col} eq "0")
			{
				print OUTPUT "0x0000";
			} else {
				print OUTPUT "0x".$utlmap{$row.",".$col};
			}
			if($col != 255)
			{
				print OUTPUT ",";
			}
			if(($col % 16) == 15)
			{
				print OUTPUT "\n";
			} else {
				print OUTPUT " ";
			}
			$casemappingbytes += 2;
		}
		print OUTPUT "};\n\n\n";
	} else {
		$utlrow[$row] = 0;
	}
}



print OUTPUT "kvi_wchar_t * kvirc_case_map_utl[256] =\n";
print OUTPUT "{\n";
for $row (0..255)
{
	if(($row % 8) == 0)
	{
		print OUTPUT "	";
	}
	if($utlrow[$row] == 0)
	{
		print OUTPUT "case_xtx_XX";
	} else {
		print OUTPUT "case_utl_".sprintf("%02X",$row);
	}
	if($row != 255)
	{
		print OUTPUT ",";
	}
	if(($row % 8) == 7)
	{
		print OUTPUT "\n";
	} else {
		print OUTPUT " ";
	}
	$casemappingbytes += 4;
}
print OUTPUT "};\n\n\n";

print OUTPUT "// Case mapping tables are ".$casemappingbytes." bytes long\n\n";

close(OUTPUT);
