# direct mapping


SIZE="0"

AUX=""

ENCODING=$2

if test -z "$ENCODING"; then
	ENCODING="THISENCODING"
fi

DATA=`zcat $1 | sed -e '/^#/d' | sed -e '/^%/d' | sed -e '/END CHARMAP/d'`

echo "" > mapping.cpp
echo "// $ENCODING character mapping tables" >> mapping.cpp
echo "" >> mapping.cpp

echo "static kvi_wchar_t ${ENCODING}_2_unicode[0x100]=" >> mapping.cpp
echo "{" >> mapping.cpp

echo "Extracting decode table"

for A in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
	for B in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
		XXX=`echo "$DATA" | grep -i "/x${A}${B}" | sed -e 's/<U/0x/g' | sed -e 's/>.*//g' | sed -e 's/[ 	]*//g'`

		if test -z "$AUX"; then
			echo -n "	" >> mapping.cpp
		fi
		AUX="x$AUX"
		echo -n "."

		if test -z "$XXX"; then
			echo "Empty ?"
			XXX="0x00${A}${B}"
			DATA="$DATA
<U00${A}${B}> /x${A}${B} KVIRC ADDED ENTRY"
		fi

		echo -n $XXX >> mapping.cpp
		SIZE=`expr $SIZE + 4`

		if test "$AUX" = "xxxxxxxx"; then
			AUX=""
			if test "${A}${B}" = "ff"; then
				echo "" >> mapping.cpp
			else
				echo "," >> mapping.cpp
			fi
		else
			echo -n ", " >> mapping.cpp
		fi
	done;
done;

echo "};" >> mapping.cpp

echo "" >> mapping.cpp

# inverse mapping

echo ""
echo "Extracting encode table"

COUNT="0"


echo "   Building null sub-table"

echo "static unsigned char unicode_2_${ENCODING}_XX[0x100]="  >> mapping.cpp
echo "{" >> mapping.cpp

for A in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
	for B in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
		echo -n "."
		if test -z "$AUX"; then
			echo -n "	" >> mapping.cpp
		fi
		echo -n "0x3f" >> mapping.cpp

		SIZE=`expr $SIZE + 1`

		AUX="x$AUX"
		if test "$AUX" = "xxxxxxxx"; then
			AUX=""
			if test "${A}${B}" = "ff"; then
				echo "" >> mapping.cpp
			else
				echo "," >> mapping.cpp
			fi
		else
			echo -n ", " >> mapping.cpp
		fi
	done;
done;

echo "};" >> mapping.cpp


echo ""
echo "   Extracting inverse mapping"

for A in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
	for B in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
		rm -f "plane_${A}${B}.dat"
		EXISTS=`echo "$DATA" | grep -i "U${A}${B}"`
		if test -n "$EXISTS"; then
			echo "      Unicode plane ${A}${B} seems to contain mappings"

			for C in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
				for D in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
					XXX=`echo "$DATA" | grep -i "U${A}${B}${C}${D}"`
	
					if test -n "$XXX"; then
						DATA=`echo "$DATA" | grep -v "U${A}${B}${C}${D}"`
						COUNT=`expr $COUNT + 1`
						echo $XXX >> "plane_${A}${B}.dat"
						echo $XXX : $COUNT
						if test "$COUNT" = "256"; then
							break 4
						fi
					fi
				done
			done
		fi
	done
done

echo ""

echo "" >> mapping.cpp

echo "   Building mapping tables"

for A in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
	for B in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
		if test -f "plane_${A}${B}.dat"; then
			echo "static unsigned char unicode_2_${ENCODING}_${A}${B}[0x100]="  >> mapping.cpp
			echo "{" >> mapping.cpp

			AUX=""

			DATA=`cat plane_${A}${B}.dat`

			echo -n "."

			for C in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
				for D in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
					XXX=`echo "$DATA" | grep -i "U${A}${B}${C}${D}" | sed -e 's/<U[0-9a-fA-F]*>[ 	]*\//0/g' | sed -e 's/[ ][ ]*.*\$//g'`
					if test -z "$AUX"; then
						echo -n "	" >> mapping.cpp
					fi
					AUX="x$AUX"


					if test -z "$XXX"; then
						XXX="0x3f"
					fi

					echo -n $XXX >> mapping.cpp
					SIZE=`expr $SIZE + 1`

					if test "$AUX" = "xxxxxxxx"; then
						AUX=""
						if test "${C}${D}" = "ff"; then
							echo "" >> mapping.cpp
						else
							echo "," >> mapping.cpp
						fi
					else
						echo -n ", " >> mapping.cpp
					fi
				done
			done

			echo "};" >> mapping.cpp
		fi
	done
done

echo ""

echo "   Building encoding table"

echo "static unsigned char * unicode_2_${ENCODING}[0x100]="  >> mapping.cpp
echo "{" >> mapping.cpp

for A in 0 1 2 3 4 5 6 7 8 9 a b c d e f; do
	for B in 0 1 2 3 4 5 6 7 8 9 a b c d e f ; do
		echo -n "."
		if test -z "$AUX"; then
			echo -n "	" >> mapping.cpp
		fi

		if test -f "plane_${A}${B}.dat"; then
			rm -f plane_${A}${B}.dat
			echo -n "unicode_2_${ENCODING}_${A}${B}" >> mapping.cpp
		else
			echo -n "unicode_2_${ENCODING}_XX" >> mapping.cpp
		fi

		SIZE=`expr $SIZE + 4`

		AUX="x$AUX"
		if test "$AUX" = "xxxx"; then
			AUX=""
			if test "${A}${B}" = "ff"; then
				echo "" >> mapping.cpp
			else
				echo "," >> mapping.cpp
			fi
		else
			echo -n ", " >> mapping.cpp
		fi
	done;
done;

echo "};" >> mapping.cpp

echo "" >> mapping.cpp
echo "// $ENCODING tables are $SIZE bytes" >> mapping.cpp

echo ""
echo "DONE : tables are $SIZE bytes"

