//
//   File : optw_userlist.cpp
//   Creation date : Sat Aug 11 2001 03:29:52 CEST by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 2001 Szymon Stefanek (stefanek@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#include "optw_userlist.h"

#include <qlayout.h>

#include "kvi_options.h"
#include "kvi_locale.h"
#include "kvi_userlistview.h"

//#warning "Info tips"

KviUserListLookOptionsWidget::KviUserListLookOptionsWidget(QWidget * parent)
: KviOptionsWidget(parent,"userlistlook_options_widget")
{
	createLayout(14,2);

	addFontSelector(0,0,1,0,__tr2qs("Font"),KviOption_fontUserListView);
	addColorSelector(0,1,1,1,__tr2qs("Background color"),KviOption_colorUserListViewBackground);
	addColorSelector(0,2,1,2,__tr2qs("Channel admin foreground color"),KviOption_colorUserListViewChanAdminForeground);
	addColorSelector(0,3,1,3,__tr2qs("Op foreground color"),KviOption_colorUserListViewOpForeground);
	addColorSelector(0,4,1,4,__tr2qs("Half-op foreground color"),KviOption_colorUserListViewHalfOpForeground);
	addColorSelector(0,5,1,5,__tr2qs("Voice foreground color"),KviOption_colorUserListViewVoiceForeground);
	addColorSelector(0,6,1,6,__tr2qs("User-op foreground color"),KviOption_colorUserListViewUserOpForeground);
	addColorSelector(0,7,1,7,__tr2qs("Normal foreground color"),KviOption_colorUserListViewNormalForeground);
	addColorSelector(0,8,1,8,__tr2qs("Selection foreground color"),KviOption_colorUserListViewSelectionForeground);
	addColorSelector(0,9,1,9,__tr2qs("Selection background color"),KviOption_colorUserListViewSelectionBackground);
	KviBoolSelector * b = addBoolSelector(0,10,1,10,__tr2qs("Draw grid"),KviOption_boolUserListViewDrawGrid);
	connect(b,
		SIGNAL(toggled(bool)),
		addColorSelector(0,11,1,11,__tr2qs("Grid color"),KviOption_colorUserListViewGrid,KVI_OPTION_BOOL(KviOption_boolUserListViewDrawGrid)),
		SLOT(setEnabled(bool)));
	QLabel * l = new QLabel(__tr2qs("Grid type"),this);
	l->setEnabled(KVI_OPTION_BOOL(KviOption_boolUserListViewDrawGrid));
	connect(b,SIGNAL(toggled(bool)),l,SLOT(setEnabled(bool)));
	addWidgetToLayout(l,0,12,0,12);
	m_pGridTypeCombo = new QComboBox(false,this);
	addWidgetToLayout(m_pGridTypeCombo,1,12,1,12);
	m_pGridTypeCombo->insertItem(__tr2qs("3D grid"));
	m_pGridTypeCombo->insertItem(__tr2qs("3D buttons"));
	m_pGridTypeCombo->insertItem(__tr2qs("Plain grid"));
	m_pGridTypeCombo->insertItem(__tr2qs("Dotted grid"));
	m_pGridTypeCombo->setCurrentItem(0);
	m_pGridTypeCombo->setEnabled(KVI_OPTION_BOOL(KviOption_boolUserListViewDrawGrid));
	connect(b,SIGNAL(toggled(bool)),m_pGridTypeCombo,SLOT(setEnabled(bool)));

	addPixmapSelector(0,13,1,13,__tr2qs("Background image"),KviOption_pixmapUserListViewBackground);

	layout()->setColStretch(0,1);
	layout()->setRowStretch(13,1);
}

KviUserListLookOptionsWidget::~KviUserListLookOptionsWidget()
{
}


void KviUserListLookOptionsWidget::commit()
{
	KviOptionsWidget::commit();
	KVI_OPTION_UINT(KviOption_uintUserListViewGridType) = m_pGridTypeCombo->currentItem();
	if(KVI_OPTION_UINT(KviOption_uintUserListViewGridType) > KVI_USERLISTVIEW_GRIDTYPE_MAXIMUM)
		KVI_OPTION_UINT(KviOption_uintUserListViewGridType) = KVI_USERLISTVIEW_GRIDTYPE_DEFAULT;
	
}


KviUserListFeaturesOptionsWidget::KviUserListFeaturesOptionsWidget(QWidget * parent)
: KviOptionsWidget(parent,"userlistfeatures_options_widget")
{
	createLayout(3,1);

	addBoolSelector(0,0,0,0,__tr("Show user channel icons"),KviOption_boolShowUserChannelIcons);
	addBoolSelector(0,1,0,1,__tr("Show user channel state"),KviOption_boolShowUserChannelState);

	addRowSpacer(0,2,0,2);
}

KviUserListFeaturesOptionsWidget::~KviUserListFeaturesOptionsWidget()
{
}

#include "m_optw_userlist.moc"
