export PATH="$PATH:/cygdrive/c/programmi/bin:/C:\\Programmi\\cygwin\\bin"

PROJECTDIR="/home/Szymon/kvirccvs/kvirc"
PACKAGEDIR="/home/Szymon/kvirccvs/kvirc/win32build/package"

cd $PROJECTDIR

# Make the directories

echo "Preparing distribution"
echo "Making $PACKAGEDIR"

mkdir -p $PACKAGEDIR


##############################################################################

SUBDIRS="pics doc doc/scriptexamples \
	doc/scriptexamples/mp3share \
	doc/scriptexamples/playing \
	doc/scriptexamples/antiidle \
	doc/scriptexamples/runmenu \
	modules \
	modules/caps \
	modules/caps/crypt \
	modules/caps/tool \
	modules/caps/serverimport \
	defscript \
	config \
	config/modules \
	help \
	help/en \
	license \
	locale"

for adir in $SUBDIRS; do
	echo "mkdir -p $PACKAGEDIR/$adir"
	mkdir -p $PACKAGEDIR/$adir
done

##############################################################################

docopy()
{
	echo "cp -f $1 $2"
	cp -f $1 $2 || exit 0
}



##############################################################################

docopy $PROJECTDIR/README $PACKAGEDIR/README.txt $PACKAGEDIR/
docopy $PROJECTDIR/doc/scriptexamples/mp3share/mp3share_icon.png $PACKAGEDIR/doc/scriptexamples/mp3share/
docopy $PROJECTDIR/doc/scriptexamples/mp3share/mp3share.kvs $PACKAGEDIR/doc/scriptexamples/mp3share/
docopy $PROJECTDIR/doc/scriptexamples/playing/playing_icon.png $PACKAGEDIR/doc/scriptexamples/playing/
docopy $PROJECTDIR/doc/scriptexamples/playing/playing.kvs $PACKAGEDIR/doc/scriptexamples/playing/
docopy $PROJECTDIR/doc/scriptexamples/antiidle/antiidle.kvs $PACKAGEDIR/doc/scriptexamples/antiidle/
docopy $PROJECTDIR/doc/scriptexamples/runmenu/runmenu.kvs $PACKAGEDIR/doc/scriptexamples/runmenu/

CONFIGS=`ls $PROJECTDIR/data/config/*.kvc`

for afile in $CONFIGS; do
	docopy $afile $PACKAGEDIR/config/
done

docopy $PROJECTDIR/data/defscript/default.kvs $PACKAGEDIR/defscript/

rm -f $PACKAGEDIR/pics/*.png

PICFILES=$(find ./ -name "*.png")

for afile in $PICFILES; do
	docopy $afile $PACKAGEDIR/pics/
done

DLLS=`ls $BASEDIR/*.dll`
for afile in $DLLS; do
	docopy $afile $PACKAGEDIR/
done

docopy $PROJECTDIR/doc/COPYING $PACKAGEDIR/license/

docopy $PROJECTDIR/src/modules/tip/libkvitip.kvc $PACKAGEDIR/config/modules/

docopy $PROJECTDIR/src/modules/lamerizer/lamerizer $PACKAGEDIR/modules/caps/crypt/
docopy $PROJECTDIR/src/modules/rijndael/caps/rijndael $PACKAGEDIR/modules/caps/crypt/
docopy $PROJECTDIR/src/modules/filetransferwindow/caps/filetransferwindow $PACKAGEDIR/modules/caps/tool/
docopy $PROJECTDIR/src/modules/mircimport/caps/mircimport $PACKAGEDIR/modules/caps/serverimport/

exit


##########################################################################################

DOCS="$PROJECTDIR/help/en/*.html"

for afile in $DOCS; do
	docopy $afile $PACKAGEDIR/help/en/
done

docopy $PROJECTDIR/data/helppics/helplogoleft.png $PACKAGEDIR/help/en/
docopy $PROJECTDIR/data/helppics/helplogoright.png $PACKAGEDIR/help/en/


MOS=`ls $BASEDIR/locale/*.mo`

# echo "MOS is $MOS"

for afile in $MOS; do
	docopy $afile $PACKAGEDIR/locale/
done

MODULES=`ls $PROJECTDIR/src/modules/*/$TARGET/*.dll`

# echo "MODULES is $MODULES"

for afile in $MODULES; do
	docopy $afile $PACKAGEDIR/modules/
done

echo "DONE!"
